[package]
name = "dnp3"
version = "1.3.0-rc2"
authors = ["Step Function I/O LLC <info@stepfunc.io>"]
edition = "2021"
license-file = "../LICENSE.txt"
description = "Rust implementation of DNP3 (IEEE 1815) with idiomatic bindings for C, C++, .NET, and Java"
homepage = "https://stepfunc.io/products/libraries/dnp3/"
repository = "https://github.com/stepfunc/dnp3"
keywords = ["dnp3", "ics", "scada", "security", "modbus"]
categories = ["network-programming"]
readme = "README.md"
exclude = ["codegen"] # the scala code used to generate parts of the crate

[dependencies]
tracing = "0.1"
chrono = "0.4"
tokio = { version = "1", features = ["net", "sync", "io-util", "io-std", "time", "rt", "rt-multi-thread", "macros"] }
xxhash-rust = { version = "0.8.2", features = ["xxh64"] }
scursor = "0.1.0"

# TLS dependencies
pem = { version = "1.0", optional = true }
pkcs8 = { version = "0.9", features = ["encryption", "pem", "std"], optional = true }
rx509 = { version = "0.2", optional = true }
tokio-rustls = { version = "0.23", features = ["dangerous_configuration", "tls12"], default-features = false, optional = true }

# serial dependencies
tokio-serial = { version = "=5.4.3", optional = true }

[dev-dependencies]
futures = { version = "0.3.24" }
clap = { version = "4.0", features = ["derive"] }
sfio-tokio-mock-io = "0.2.0"
assert_matches = "1.2"
tracing-subscriber = "0.2"
tokio-util = { version = "0.7", features = ["codec"] }
tokio-stream = { version = "0.1.1" }
rand = "0.8"
tokio = { version = "1", features = ["test-util"] }

[features]
default = ["tls", "serial"]
ffi = [] # this feature flag is only used when building the FFI
tls = ["pem", "pkcs8", "rx509", "tokio-rustls"]
serial = ["tokio-serial"]
